/*
	Based off of code by Nathan Smith of SonSpring.com.
	http://sonspring.com/journal/jquery-iframe-sizing
	
	Thanks Nathan.
	
	Version 0.1
*/

var builder_iframe_resize =
	function() {
		var max_height = 500;
		
		// Set specific variable to represent all iframe tags.
		var iFrames = document.getElementsByTagName('iframe');
		
		// Resize height
		var iResize = function() {
			// Iterate through all iframes in the page.
			for (var i = 0, j = iFrames.length; i < j; i++) {
				var new_height = iFrames[i].contentWindow.document.body.offsetHeight;
				
				if(new_height > 0) {
					if(new_height > max_height)
						new_height = max_height;
					
					// Set inline style to equal the body height of the iframed content.
					iFrames[i].style.height = new_height + 'px';
					
					var e = iFrames[i];
					setTimeout(function() { resize_width(e); }, 100);
				}
			}
		}
		
		// Resize width
		var resize_width = function(e) {
			var iframe_container_width = jQuery(e).parent().width();
			var layout_width = jQuery(e).contents().find(".builder-container").width();
			
			e.style.width = iframe_container_width + "px";
			
			if((iframe_container_width - layout_width) < 100)
				jQuery(e).contents().find('body').css('width', (layout_width + 100) + "px");
			else
				jQuery(e).contents().find('body').css('width', '100%');
		}
		
		// Check if browser is Safari or Opera.
		if(jQuery.browser.safari || jQuery.browser.opera) {
			// Start timer when loaded.
			jQuery('iframe').load(
				function() {
					setTimeout(iResize, 0);
				}
			);
		}
		else {
			// For other good browsers.
			jQuery('#style-preview').load(
				function() {
					var new_height = this.contentWindow.document.body.offsetHeight;
					
					if(new_height > 0) {
						if(new_height > max_height)
							new_height = max_height;
						
						// Set inline style to equal the body height of the iframed content.
						this.style.height = new_height + 'px';
						
						var e = this;
						setTimeout(function() { resize_width(e); }, 100);
					}
				}
			);
		}
		
		jQuery(window).resize(
			function() {
				jQuery('iframe').each(
					function() {
						var e = this;
						setTimeout(function() { resize_width(e); }, 100);
					}
				);
			}
		);
		
		jQuery('.postbox h3, .postbox .handlediv').click(
			function() {
				jQuery('iframe').each(
					function() {
						var e = this;
						setTimeout(function() { resize_width(e); }, 100);
					}
				);
			}
		);
		
		jQuery('#adminmenu .separator').click(
			function() {
				jQuery('iframe').each(
					function() {
						var e = this;
						setTimeout(function() { resize_width(e); }, 100);
					}
				);
			}
		);
	}


jQuery(document).ready(
	function() {
		builder_iframe_resize();
	}
);
